;; $Id: bound-vars.tst,v 1.6 2005/02/18 15:05:34 leavens Exp leavens $

(newline)
(displayln "Test case of $Date: 2005/02/18 15:05:34 $")
(newline)

(define lexp1 '(lambda (x) (f x)))
(define lexp2 `(lambda (z) (,lexp1 (g (h y)))))
(define lexp3 `(lambda (f) ,lexp2))
(define lexp4 `(,lexp3 (car (cdr (x (y (quote z)))))))
(define lexp5 `(lambda (y) ,lexp4))
(define lexp6 `(lambda (f) ,lexp4))
(define lexp7 `(,lexp5 ,lexp2))

(define run-regression-tests-set-equal?
  ;; TYPE: (-> ((3-list scheme-exp symbol datum)) void)
  (run-regression-tests-maker
   set-equal?
   pretty-print
   pretty-print))

(run-regression-tests-set-equal?
 `(
   ( (bound-vars (parse-lambda-1-quote-exp 'x)) = (set) )
   ( (bound-vars (parse-lambda-1-quote-exp '(quote z))) = (set) )
   ( (bound-vars (parse-lambda-1-quote-exp '(x y))) = (set) )
   ( (bound-vars (parse-lambda-1-quote-exp '(lambda (x) (lambda (x) y))))
     = (set) )
   ( (bound-vars (parse-lambda-1-quote-exp ',lexp1)) = (set 'x) )
   ( (bound-vars (parse-lambda-1-quote-exp ',lexp2)) = (set 'x) )
   ( (bound-vars (parse-lambda-1-quote-exp ',lexp3)) = (set 'f 'x) )
   ( (bound-vars (parse-lambda-1-quote-exp ',lexp4)) = (set 'f 'x) )
   ( (bound-vars (parse-lambda-1-quote-exp ',lexp5)) = (set 'y 'f 'x) )
   ( (bound-vars (parse-lambda-1-quote-exp ',lexp6)) = (set 'f 'x) )
   ( (bound-vars (parse-lambda-1-quote-exp ',lexp7)) = (set 'y 'f 'x) )
   )
 )

