;;; $Id: append-map.tst,v 1.1 2005/02/03 03:33:22 leavens Exp $

(newline)
(newline)
(displayln "Test case of $Date: 2005/02/03 03:33:22 $")
(newline)

(run-regression-tests-equal?
 `(
    ( (append-map (lambda (x) (list x))
                '(copies the argument list))
      ==> (copies the argument list) )
    ( (append-map (lambda (x) (list x))
                '())
      ==> () )
    ( (append-map (lambda (n) (if (= n 3) '() (list n)))
                '(3 4 2 3 7))
      ==> (4 2 7) )
    ( (append-map (lambda (x) (list x 7 (+ x 1)))
                '(5 4 1 2 100 50 10 3))
      ==> (5 7 6 4 7 5 1 7 2 2 7 3 100 7 101 50 7 51 10 7 11 3 7 4) )
    ( (append-map (lambda (x) (list (list x 7 (+ x 1))))
                '(5 4 1))
      ==> ((5 7 6) (4 7 5) (1 7 2)) )
    ( (append-map (lambda (x) (if (= 5 x) '() (list (list x 7 (+ x 1)))))
                '(5 4 1))
      ==> ((4 7 5) (1 7 2)) )
   ))

(newline)
(newline)
