;;; $Id: largest-width.tst,v 1.1 2005/02/09 23:33:12 leavens Exp $

(newline)
(displayln "Test case of $Date: 2005/02/09 23:33:12 $")
(newline)

(run-regression-tests-equal?
 `(
   ( (largest-width (parse-window-layout '(horizontal )))
     ==> 0 )
   ( (largest-width (parse-window-layout '(vertical )))
     ==> 0 )
   ( (largest-width (parse-window-layout '(window simpsons 30 40)))
     ==> 30 )
   ( (largest-width (parse-window-layout '(window family-guy 70 11)))
     ==> 70 )
   ( (largest-width
      (parse-window-layout '(horizontal (window family-guy 30 15)
			                (window futurama 89 55))))
     ==> 89 )
   ( (largest-width
      (parse-window-layout
           '(vertical
              (vertical (window simpsons 200 150))
              (horizontal (horizontal (window news 5 5)))
  	      (horizontal (window family-guy 30 15)
		          (window futurama 89 55)))))
     ==> 200 )

   ( (largest-width
      (parse-window-layout
           '(vertical
              (vertical (window simpsons 200 150))
              (horizontal (horizontal (window news 5 5)))
  	      (horizontal (window family-guy 30 15)
			  (vertical
			   (vertical (horizontal
				     (window big 501 34 ))))
			  (vertical (horizontal (horizontal )))
		          (window futurama 89 55)))))
     ==> 501 )

   ))

(newline)
(newline)
