;;; $Id: shrink-to.tst,v 1.1 2005/02/09 22:33:04 leavens Exp $

(newline)
(displayln "Test case of $Date: 2005/02/09 22:33:04 $")
(newline)

(run-regression-tests-equal?
 `(
   ( (shrink-to 10 39 (parse-window-layout '(vertical )))
     ==> (vertical) )
   ( (shrink-to 10 39 (parse-window-layout '(horizontal )))
     ==> (horizontal) )
   ( (shrink-to 10 39 (window 'simpsons 30 40))
     ==> (window simpsons 10 39) )
   ( (shrink-to 10 39 (window 'simpsons 30 11))
     ==> (window simpsons 10 11) )
   ( (shrink-to 80 39 (window 'family-guy 30 11))
     ==> (window family-guy 30 11) )
   ( (shrink-to 80 5 (window 'family-guy 30 11))
     ==> (window family-guy 30 5) )
   ( (shrink-to 20 30 (horizontal
		       (list (window 'family-guy 30 15)
			     (window 'futurama 89 55))))
     ==> (horizontal (window family-guy 20 15)
		     (window futurama 20 30)) )
   ( (shrink-to 20 30 (vertical
                       (list (vertical (list (window 'simpsons 200 150)))
                             (horizontal
			      (list
			       (horizontal (list (window 'news 5 5)))))
			     (horizontal
			      (list (window 'family-guy 30 15)
				    (window 'futurama 89 55))))))
     ==> (vertical (vertical (window simpsons 20 30))
		   (horizontal
		    (horizontal (window news 5 5)))
		   (horizontal
		    (window family-guy 20 15)
		    (window futurama 20 30))) )
   ( (shrink-to 20 30 (vertical
                       (list (vertical (list (window 'simpsons 200 150)))
                             (horizontal
			      (list
			       (horizontal
				(list
				 (vertical '())
				 (horizontal '())
				 (window 'news 5 5)))))
			     (horizontal
			      (list (window 'family-guy 30 15)
				    (window 'futurama 89 55))))))
     ==> (vertical (vertical (window simpsons 20 30))
		   (horizontal
		    (horizontal (vertical) (horizontal) (window news 5 5)))
		   (horizontal
		    (window family-guy 20 15)
		    (window futurama 20 30))) )

   ))

(newline)
(newline)
