;;; $Id: subst-identifier.tst,v 1.1 2005/02/10 07:46:23 leavens Exp leavens $

(newline)
(displayln "Test case of $Date: 2005/02/10 07:46:23 $")
(newline)

(run-regression-tests-equal?
 `(
   ( (subst-identifier 'new 'old (exp-stmt (var-exp 'old)))
                                 = (exp-stmt (var-exp 'new)) )
   ( (subst-identifier 'new 'old (exp-stmt (var-exp 'x)))
                                 = (exp-stmt (var-exp 'x)) )
   ( (subst-identifier 'x 'a (exp-stmt (var-exp 'a)))
                             = (exp-stmt (var-exp 'x)) )
   ( (subst-identifier 'x 'a (set-stmt 'a (num-exp 3)))
                             = (set-stmt 'x (num-exp 3)) )
   ( (subst-identifier 'x 'a
           (set-stmt 'a (begin (list (set-stmt 'a (num-exp 3))) (var-exp 'b))))
         = (set-stmt 'x (begin (list (set-stmt 'x (num-exp 3))) (var-exp 'b))) )

   ( (subst-identifier 'x 'a
           (parse-statement '(set! a (begin (set! a 3) (set! b a) b))))
         = (parse-statement '(set! x (begin (set! x 3) (set! b x) b))) )

   ( (subst-identifier 'x 'a (parse-statement '(begin a)))
     = (parse-statement '(begin x)) )

   ( (subst-identifier 'x 'a (parse-statement '(set! a (begin (begin a)))))
     = (parse-statement '(set! x (begin (begin x)))) )

   ( (subst-identifier 'x 'a
       (parse-statement
	'(begin (set! a (begin 3)) (set! a (begin (set! a (begin 4)) a))
		5 6 a (begin a) 5 (begin (begin (begin b) a))
		(begin (set! b (begin a)) b))))
     = (parse-statement
 	'(begin (set! x (begin 3)) (set! x (begin (set! x (begin 4)) x))
		5 6 x (begin x) 5 (begin (begin (begin b) x))
		(begin (set! b (begin x)) b))) )
   
   ))

(newline)
(newline)
