;; $Id: lists.tst,v 1.2 2005/03/07 06:24:08 leavens Exp leavens $

(newline)
(displayln "Test case of $Date: 2005/03/07 06:24:08 $")
(newline)

(run-regression-tests-equal?
 `(
   ( (run "emptylist") ==> () )
   ( (run "cons(342, emptylist)") ==> (342) )
   ( (run "list(1, 2, 3)") ==> (1 2 3) )
   ( (run "car(list(5, 4, 1, 9, 8, 7))") ==> 5 )
   ( (run "cdr(list(5, 4, 1, 9, 8, 7))") ==> (4 1 9 8 7) )
   ( (run "cons(4, emptylist)") ==> (4))
   ( (run "car(cons(4, emptylist))") ==> 4)
   ( (run "cdr(cons(4, emptylist))") ==> ())
   ( (run "cons(5, cons(4, emptylist))") ==> (5 4))
   ( (run "car(cons(5, cons(4, emptylist)))") ==> 5)
   ( (run "cdr(cons(5, cons(4, emptylist)))") ==> (4))
   ( (run "list(list())") ==> (()) )
   ( (run "list(cons(1, cons(2, emptylist)), cons(3, emptylist))")
     ==> ((1 2) (3)) )
   ))
