;; $Id: dynamic-scoping.tst,v 1.2 2005/03/21 05:15:02 leavens Exp $

(newline)
(displayln "Test case of $Date: 2005/03/21 05:15:02 $")
(newline)

(run-regression-tests-equal?
 `(
   ( (run "let a = 3
           in let p = proc(x) +(x,a)
                  a = 5
              in *(a, (p 2))")
     ==> 35 )
   ( (run "let three = 3
           in let add3 = proc(i) +(i, three)
                  three = 5
              in *(three, (add3 2))")
     ==> 35)
   ( (run "let fact = proc(n) add1(n)
           in let fact = proc (n)
                         if zero?(n)
                         then 1
                         else *(n, (fact sub1(n)))
              in (fact 5)")
     ==> 120 )
   ( (run "let a = 3
           in let p = proc() +(x, a)
                  f = proc(x, y) *((p), y)
                  a = 5
              in *(a, (f let a = 2 in a 1))")
     ==> 35)
   ( (run "let a = 3
           in let p = proc() +(x, a)
                  f = proc(x, a) *((p), a)  %% ***
                  a = 5
              in *(a, (f let a = 2 in a 1))")
     ==> 15)
   ( (run "let a = 3
           in let p = proc() +(x, a)
                  f = proc(x, y) *((p), y)
                  a = 5
              in *(a, let a = 2 in (f a 1))")
     ==> 20)
   )
 )
