;;; $Id: map-sym-exp.tst,v 1.2 2005/02/07 17:52:07 leavens Exp leavens $

(newline)
(newline)
(displayln "Test case of $Date: 2005/02/07 17:52:07 $")
(newline)

(run-regression-tests-equal?
 `(
   ( (map-sym-exp (lambda (x) (symbol 'y))
		  (symbol 'x))
     ==> y )
   ( (map-sym-exp (lambda (x) (if (eq? x 'a) (symbol 'y) x))
		  (symbol 'a))
     ==> y )
   ( (map-sym-exp (lambda (x) (if (eq? x 'a) (symbol 'y) x))
		  (symbol 'b))
     ==> b )
   ( (map-sym-exp (lambda (x) (if (eq? x 'a) (symbol 'y) x))
		  (s-list '()))
     ==> () )
   ( (map-sym-exp (lambda (x) (if (eq? x 'a) (symbol 'y) x))
		  (parse-sym-exp '(a b () c)))
     ==> (y b () c) )

   ( (map-sym-exp (lambda (x) (if (eq? x 'coms) 'cpre 'mis))
		  (parse-sym-exp '((a dept) ((of))
				   (coms (() or math)) ())))
     ==> ((mis mis) ((mis))
	  (cpre (() mis mis)) ()) )
   )
 )

(newline)
(newline)
